package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.UserUpdateLog;
import com.izouma.awesomeadmin.service.UserUpdateLogService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/userUpdateLog")
public class UserUpdateLogController {

    @Autowired
    private UserUpdateLogService userUpdateLogService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(UserUpdateLog record) {
        List<UserUpdateLog> pp = userUpdateLogService.getUserUpdateLogList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getUserUpdateLog", method = RequestMethod.GET)
    @ResponseBody
    public Result getUserUpdateLog(@RequestParam(required = false, value = "id") String id) {
        UserUpdateLog data = userUpdateLogService.getUserUpdateLogById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(UserUpdateLog record) {
        UserUpdateLog data = userUpdateLogService.getUserUpdateLog(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, UserUpdateLog record) {
        Map<String, Object> result = new HashMap<>();

        List<UserUpdateLog> pp =userUpdateLogService.getUserUpdateLogByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(UserUpdateLog record) {
        boolean num = userUpdateLogService.createUserUpdateLog(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateUserUpdateLog(UserUpdateLog record) {
        boolean num = userUpdateLogService.updateUserUpdateLog(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteUserUpdateLog(UserUpdateLog record) {

        boolean num = userUpdateLogService.deleteUserUpdateLog(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, UserUpdateLog record) throws Exception {

    List<UserUpdateLog> userUpdateLogs = userUpdateLogService.getUserUpdateLogList(record);


        String sheetName = "user_update_log";
        String titleName = "更新操作日志数据表";
        String fileName = "更新操作日志表";
        int columnNumber = 10;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "表名" ,   "IP" ,   "内容" ,   "目标id"  };
        String[][] dataList = new String[userUpdateLogs.size()][10];

        for (int i = 0; i < userUpdateLogs.size(); i++) {

                        dataList[i][0] = String.valueOf(userUpdateLogs.get(i).getId());
                        dataList[i][1] = String.valueOf(userUpdateLogs.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(userUpdateLogs.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(userUpdateLogs.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(userUpdateLogs.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(userUpdateLogs.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(userUpdateLogs.get(i).getTableName());
                        dataList[i][7] = String.valueOf(userUpdateLogs.get(i).getIp());
                        dataList[i][8] = String.valueOf(userUpdateLogs.get(i).getRemark());
                        dataList[i][9] = String.valueOf(userUpdateLogs.get(i).getUpdateId());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

